grammar NFA;

/* Parser Rules */

start:       init production* final comment;

init:        (INIT EQUALS statename | );

production:  LEFT_PARENTHESIS statename COMMA (statename | EPSILON) RIGHT_PARENTHESIS EQUALS stateset;

stateset:    LEFT_BRACKET (statename (COMMA statename)* | ) RIGHT_BRACKET;

final:       FINAL EQUALS stateset;

statename:   (STATE | QUOTE anyvalue+ QUOTE);

comment:     (HASH anyvalue* | );

anyvalue:    INIT | EQUALS | LEFT_PARENTHESIS | RIGHT_PARENTHESIS | LEFT_BRACKET | RIGHT_BRACKET | COMMA | FINAL | STATE | ANYCHAR | HASH;

/* Lexer Rules */

/* Tokens */

INIT              : 'init';
EQUALS            : '=';
LEFT_PARENTHESIS  : '(';
RIGHT_PARENTHESIS : ')';
LEFT_BRACKET      : '{';
RIGHT_BRACKET     : '}';
COMMA             : ',';
FINAL             : ('final');
EPSILON           : ('ε' | '\\''e');
STATE             : ([a-zA-Z0-9] | '_' | '\'')+;
HASH              : '#';
QUOTE             : '"';

/* Characters to be ignored */
WS : [ \r\t\n]+ -> skip ;

ANYCHAR           : .;
